**Group ID - 2020 - 092**

**Research Topic : A Machine Learning Based DDoS Detection System**



**Supervisor 		- Mr. Nuwan Kuruwitaarachchi**

**Co-Supervisor 	- Mr. Kavinga Yapa Abeywardena**



Member 1(Leader) 	- IT17114172 	- A.U. Sudugala

Member 2 			- IT17106702 	- W.H.Chanuka

Member 3 			- IT17124904 	- A.M.N. Eshan

Member 4 			- IT17111034 	- U.C.S. Bandara



**Project Description**


This project proposed a solution that involves building an Intrusion Detection System to detect Distributed Denial of Service attacks using Machine Learning algorithms for a given network. Four most common and dangerous DDoS attacks and respectively four different machine learning algorithms are used to train the proposed system. 

The solution helps to utilize the network in its full capacity and secure the interconnected devices while maintaining the user satisfaction by thwarting network disruptions. Also, the system is placed behind the firewall to get maximum productivity over the network and its connected devices in order to maintain high performance. 
Due to the high cost in deploying new tools and resources to make the network fully secure and automated, detecting and mitigating the DDoS attacks are less efficient with the current procedures. Therefore, it leads to the implementation of a new system which is cost effective and efficient in identifying and mitigating DDoS attacks and easily configurable in a given network. From the beginning of this project factors such as the cost, resources and target audience should be taken into consideration.
Research Question
As DDoS attacks are spreading all over the world many types of DDoS attacks are discovered. However, there are advanced DDoS attacks which do not currently have a fool proof way to detect and mitigate. Actively repelling DDoS attacks has become one of the fundamental problems in modern networks. 
As DDoS attacks are capable of filtering to drop attack traffic before passing the normal traffic to the destination, redirecting all destinations to a third-party DNS, such as Akamai and Cloudflare are some of the practical approaches used to mitigate this fundamental threat. 
Even though with such kinds of approaches are available and requires no upgrades to the existing network infrastructure and able to handle very massive attacks, recent industrial interviews boils the fact that this approach alone is not capable especially for wide scope organizations such as web hosting organizations and governments as they are unable to handover the direct network control to a third-party security service. Hence, they must depend on their ISPs to filter out suspicious attack traffic. 

**Research Objectives**

**Main Objective :**

The main objective of the research is to provide an Intrusion Detection System which can detect the DDoS attacks using Machine Learning Algorithms by identifying the suspicious packets, dropping them and sending a notification about the activity to all the network connected authorities. Organizations will be able to provide secure communication and risk-free experience with a well-secured IoT environment through the proposed system. Most of the networks and IoT devices are very difficult to maintain because of the lack of security issues and lack of knowledge on these devices. It is required to have a proper mechanism to protect the network and interconnected IoT devices with no intruder disruptions. Along with it, there should be a mechanism to maintain the data privacy of the organization and the employees. Most of the time organizations must pay a huge amount of money to hire an expert to configure the network and it takes more time to get the outcome. 
Specific Objectives :

•	Identifying NTP Amplification attacks - IT17111034
To achieve the main objective, identifying NTP amplification attacks is very important. Here the main objective is to  filter out the normal internet traffic and identify the NTP Responses and identify whether it is NTP Amplification attack or not. After identifying the Network traffic if there is any suspicious traffic a Notification should be given. 

•	Identifying Slow Loris attacks - IT17124904
In order to achieve the main objective this specific objective proposed a way to identify the .pcap files and figure out whether it is a Slow Loris attack or not.is there any suspicious traffic, partial HTTP requests, a notification should be given to the user. Is that suspicious traffic is Slow Loris attack, system detect the attack type and ensure the availability of the systems for the legitimate users without any interruption. 

•	Identifying Mobile Botnet DDoS attacks - IT17106702
To achieve the main object, one specific objective is to identify the IRC (Internet Relay Chat) traffic beside normal traffic and figure out whether it is a Mobile Botnet DDoS attack or not. If there are any suspicious traffic, a notification should be given to the user. By identifying Mobile Botnet DDoS attack, the detection system can ensure the availability of a system for the legitimate users without any interruption. And reduce financial and other losses of the industries and governments worldwide. 

•	Identifying Volumetric attacks - IT17114172
To achieve the main object, another specific objective is to identify Volumetric attacks. The model is trained to identify very high bandwidth (more than 50 Gb+) requests received to the system. 

**Summary of Individual Components**


**Identifying Mobile Botnet DDoS attacks - IT17106702**

This component is to identify the IRC(Internet Relay Chat) traffic beside normal traffic and figure out whether it is a Mobile Botnet attack or not. If there are any suspicious traffic, a notification should be given to the user. By identifying Mobile Botnet DDoS attack, the detection system can ensure the availability of a system for the legitimate users without any interruption. And also reduce financial and other losses of the industries and governments worldwide.
Data Set used  : https://www.uvic.ca/engineering/ece/isot/datasets/

**Identifying NTP Amplification attacks - IT17111034**

This component is implementing to filter out the normal internet traffic and identify the NTP Responses and identify whether it is a NTP Amplification attack or not. After identifying the Network traffic if there is any suspicious traffic a Notification should be given.
Data Set used  : http://205.174.165.80/CICDataset/CICDDoS2019/Dataset/CSVs/ 

**Identifying Slow Loris attacks - IT17124904**

This component is to identify the .pcap files and figure out whether it is a Slow Loris attack or not.is there any suspicious traffic, partial HTTP requests, a notification should be given to the user. Is that suspicious traffic is Slow Loris attack, system detect the attack type and ensure the availability of the systems for the legitimate users without any interruption.
Data Set used  : http://205.174.165.80/CICDataset/ISCX-SlowDos-2016/Dataset/

**Identifying Volumetric attacks - IT17114172**

Volumetric Distributed Denial of Service attack is one of the severe malicious attack which can be seen on Internet and it is responsible for more than half of all kinds of those attacks. This components are to detect volumetric attacks using machine learning and to make a safe environment for the users without DDoS disruption.
Data Set used : Extracted DDoS Flows from CSE-CIC-IDS2018-  AWS, CICIDS2017, CIC DoS dataset(2016)

**System Architecture**

**System Overview Diagram**

http://gitlab.sliit.lk/2020---092/2020-092/blob/master/Images/system_overview_diagram.JPG

According to the above diagram, first malicious traffic signatures should be obtained from the raw data and then added to the database. In order do this, datasets which are related to the NTP Amplification attacks, Mobile Botnet attacks, Slowloris attacks and Volumetric attacks are used. Then, by using the feature selection, generation of the SDS will be done and afterwards the Machine Learning Algorithm is being trained. Then it is supplied to the system of traffic classification.

**Other Necessary Instructions to run the code:**


**Run it on your PC**

1.	Install the following
1.	git
2.	python
3.	npm
4.	pip

2. Clone the repository
	git clone http://gitlab.sliit.lk/2020---092/2020-092.git

3. Run the application.py file using PyCharm.

4. Open the WANHEDA Front End folder in Visual Studio Code and run.
	
	Open the Terminal in VS Code
	Run the command ‘npm start’

 
